/*-----------------------------------------------------------------------
 * Grade Calculator Program
 * Anonymous Student 2
 * COMP 1671, Project 2, Sept 29
 * This program determines a student's overall class grade based on input
 * of their scores in homework, projects, 2 exams, and lab
 -----------------------------------------------------------------------*/

#include <iostream>
#include <string>
using namespace std;

int main()
{
	
	//-------------------------------------------------------------
	// declare variables to hold input scores for each category,
	// set up as floats to accept decimal scores
	//-------------------------------------------------------------
	float homework, project, exam1, exam2, lab;
	

	//-------------------------------------------------------------
	// declare a matching set of constants that tell what percent
	// of the overall grade each category is worth (i.e. its weight)
	//-------------------------------------------------------------
	const float homeworkWeight(0.2);
	const float projectWeight(0.3);
	const float exam1Weight(0.2);
	const float exam2Weight(0.2);
	const float labWeight(0.1);

	
	//------------------------------------------------------------
	// declare variables to hold the student's last and first name,
	// the calculated weighted average, the corresponding
	// letter grade, and a flag that will tell whether the
	// student's grade was lowered due to poor project score
	//------------------------------------------------------------
	string firstName, lastName;
	float weightedAverage;
	char letterGrade;
	bool gradeReduced = false;

	
	//------------------------------------------------------------
	// create a set of constants that represent the lower
	// boundary for each letter grade (i.e the minimum score that
	// a student can recieve and still get that grade). Set them
	// so that they include the last half point from lower
	// intervals; this has the effect of rounding to the nearest
	// integer score when determing letter grade
	//------------------------------------------------------------
	const float minD(59.5);
	const float minC(69.5);
	const float minB(79.5);
	const float minA(89.5);
	
	
	//------------------------------------------------------------
	// Begin program interaction: explain the program and
	// prompt the user to input the student's name (and store it)
	//------------------------------------------------------------
	cout << endl;
	cout << "This program will calculate a student's COMP 1671 grade\n";
	cout << "based on their scores for each part of the class.\n";
	cout << endl;
	cout << "Enter the student's first and last name and press Enter: ";
	cin >> firstName >> lastName;
	
	
	//------------------------------------------------------------
	// Prompt the user to input the student's scores, store each
	// in the appropriate variable
	//------------------------------------------------------------
	cout << "\nEnter " << firstName << "'s scores for each of the\n";
	cout << "following categories (press Enter after each)...\n";
	
	cout << "Average homework grade: ";
	cin >> homework;
	
	cout << "Average project grade: ";
	cin >> project;
	
	cout << "Exam 1 (midterm) grade: ";
	cin >> exam1;

	cout << "Exam 2 (final) grade: ";
	cin >> exam2;

	cout << "Lab grade: ";
	cin >> lab;
	cout << "........................" << endl;

	
	//------------------------------------------------------------
	// Calculate the numerical (weighted) average for the student
	//------------------------------------------------------------
	weightedAverage = (homework * homeworkWeight)
		+ (project * projectWeight)
		+ (exam1 * exam1Weight) + (exam2 * exam2Weight)
		+ (lab * labWeight);

	
	//------------------------------------------------------------
	// Determine the corresponding "raw" letter grade (before
	// any deductions due to failing project grade)
	//------------------------------------------------------------
	if (weightedAverage >= minA)
		letterGrade = 'A';
	else if (weightedAverage >= minB)
		letterGrade = 'B';
	else if (weightedAverage >= minC)
		letterGrade = 'C';
	else if (weightedAverage >= minD)
		letterGrade = 'D';
	else
		letterGrade = 'F';


	//------------------------------------------------------------
	// Determine whether the letter grade needs to be reduced
	// due to a failing project grade, and do so if needed
	//------------------------------------------------------------
	if (project >= minC)
		; 	//the student passed the projects, so do nothing
	
	else 		//the student failed the projects (D or F)
		
		if (!(letterGrade == 'F' || letterGrade == 'D'))
			//then it needs to be reduced to a D
		{	
			letterGrade = 'D';
			gradeReduced = true;
		}

	
	//------------------------------------------------------------
	// Output the weighted average and letter grade, and if
	// necessary a message that the grade was reduced
	//------------------------------------------------------------
	cout << firstName << " " << lastName << " -" << endl;
	cout << "Weighted Avg: " << weightedAverage << ", Grade: "
		<< letterGrade;
	if (gradeReduced)
		cout << " (Reduced due to failing project score.)";
	
	cout << endl;
	

	return 0; //program completed successfully
}
